/*
 *  Tools & widgets for dealing with the NetWare bindery file.
 */

#ifndef BINDTOOL_H
#define BINDTOOL_H

#include "bindery.h"

/*  Descriptions of bindery security values */
const char secdesc[5][4] = {"Any","Log","Usr","Sup","Sys"};

/*  Swap 16 & 32 bit unsigned integers ("borowed" from Pandora... :)  */
uint32 swap32(uint32 n)
{
  uint8 p[4];
  p[0]=n/0x1000000;
  p[1]=n/0x10000;
  p[2]=n/0x100;
  p[3]=n;
  return (p[0]+p[1]*0x100+p[2]*0x10000+p[3]*0x1000000);
}

uint16 swap16(uint16 n)
{
  uint8 p[2];
  p[0]=n/0x100;
  p[1]=n;
  return (p[0]+p[1]*0x100);
}

/*  Convert an ID to an offset  */
uint32 idtooffset(uint32 id)
{
  return(id & 0xffff);
}

#endif

