/*
 *  NetWare bindery file structure
 */

#ifndef BINDERY_H
#define BINDERY_H

#define PACKED __attribute__((packed))

/*  Blah blah blah...  */
typedef unsigned char uint8;
typedef unsigned short uint16;
typedef unsigned long uint32;


/*  Net$Obj.Sys -  Bindery objects  */
typedef struct binderyobject    // 64 bytes
{
  uint32  id PACKED;		
  uint16  type PACKED;		
  uint8   namelen PACKED;	
  uint8   name[48] PACKED;	
  uint8   security PACKED;	
  uint32  property PACKED;	
  uint32  unknown PACKED;       //??!!
} OBJECT;

/*  Net$Prop.Sys - Object properties  */
typedef struct binderyproperty  // 34 bytes
{
  uint32  id PACKED;
  uint8   namelen PACKED;
  uint8   name[15] PACKED;
  uint8   flags PACKED;
  uint8   security PACKED;
  uint32  owner PACKED;
  uint32  next PACKED;
  uint32  value PACKED;
} PROP;


/*  Net$Val.Sys - Property values  */
typedef struct binderyvalue     // 142 bytes
{
  uint32  id PACKED;
  uint32  owner PACKED;
  uint32  next PACKED;
  uint16  sequence PACKED;
  uint8   data[128] PACKED;
} VALUE;

#endif

