#include <stdio.h>
#include "..\Common\Bindery.h"
#include "..\Common\BindTool.h"

  FILE *objfile;
  FILE *propfile;
  FILE *valfile;
  int  posstore = 0;


void displayblobvalue (uint32 valid)
{
   VALUE value;
   char tmp[20];
   int ploop, bloop;

   fseek(valfile,idtooffset(valid) * sizeof(value),SEEK_SET);
   fread(&value,sizeof(value),1,valfile);

   for ( ploop=0 ; ploop<9 ; ploop++) {
     printf("    ");
     strcpy(tmp,"................");
     for( bloop=0 ; bloop<16 ; bloop++) {
       printf("%02x ",value.data[(ploop * 16)+bloop]);
       if (value.data[(ploop * 16)+bloop] > 31 && value.data[(ploop * 16)+bloop] < 128)
         tmp[bloop] = value.data[(ploop * 16)+bloop];
     }
     printf(" %s\n",tmp);
   }

   if (value.next != -1)
     displayblobvalue(value.next);
}

void displaylistvalue (uint32 valid)
{

  VALUE value;
  OBJECT obj;
  uint32 *id;
  int i;

  fseek(valfile,idtooffset(valid) * sizeof(value),SEEK_SET);
  fread(&value,sizeof(value),1,valfile);

  id = (uint32 *)&value.data;
  for ( i=0 ; i<32 ; i++) {
    if (!*id) break;
    fseek(objfile,idtooffset(*id) * sizeof(OBJECT),SEEK_SET);
    fread(&obj,sizeof(obj),1,objfile);
    printf("    %s\n",obj.name);
    id++;
  }

  if (value.next != -1 && id)
    displaylistvalue(value.next);

  printf("\n");

}

void displayprop (uint32 propid)
{
  PROP prop;

  if (propid == -1)
    return;

  fseek(propfile,idtooffset(propid) * sizeof(prop),SEEK_SET);
  fread(&prop,sizeof(prop),1,propfile);
  printf("  %.15s\n",prop.name);
  if (prop.value != -1)
    if (prop.flags & 2) {
      displaylistvalue(prop.value);
    } else {
      displayblobvalue(prop.value);
    }

  displayprop(prop.next);
}

int main (void) {

  OBJECT obj;

  objfile = fopen("net$obj.old","rb");
  propfile = fopen("net$prop.old","rb");
  valfile = fopen("net$val.old","rb");

  while (!feof(objfile)) {
    fseek(objfile,posstore,SEEK_SET);
    fread(&obj,sizeof(obj),1,objfile);
    posstore = ftell(objfile);

    if (obj.type) {
      printf("%s\n",obj.name);
      displayprop(obj.property);
      printf("\n");
    }
  }

  fclose(objfile);
  fclose(propfile);
  fclose(valfile);

  exit(0);
}

